#include <stdio.h>

#include "..\inc\uusbd.h"
#include <process.h>    /* _beginthread, _endthread */

#define NUM_INTERFACE	0
//#define NUM_PIPE		0
#define LOOPCOUNT		10

USHORT get_max_packet(HUSB husb, DWORD if_num, DWORD pipe_num)
{
	char *buf,*p;
	USHORT max_len;
	DWORD pipe_count, len;
	BOOL ok;
	USB_CONFIGURATION_DESCRIPTOR conf;
	PUSB_ENDPOINT_DESCRIPTOR endp_descriptor;

	ok = Uusbd_GetConfigurationDescriptor(husb,(char*)&conf, sizeof(conf));
	if(!ok) return 0;
	len = conf.wTotalLength;
	buf = (char*)malloc(len);
	
	ok = Uusbd_GetConfigurationDescriptor(husb,buf, len);
	if(!ok) return 0;

	p = buf; max_len = 0; pipe_count = 0; ok = FALSE;
	while(len>0) {
		if(p[1] == USB_INTERFACE_DESCRIPTOR_TYPE){ // interface descriptor
			if((unsigned) p[2] == if_num) ok = TRUE;
			else ok = FALSE;
			pipe_count = 0;
		}
		if(p[1] == USB_ENDPOINT_DESCRIPTOR_TYPE && ok){ // endpoint descriptor
			if(pipe_count == pipe_num) { // found !!
				endp_descriptor = (PUSB_ENDPOINT_DESCRIPTOR)p;
				max_len = endp_descriptor->wMaxPacketSize;
				break;
			}
			pipe_count++; // fix Ver1.1
		}
		p += p[0];
		len -= p[0];
	}
	free(buf);
	return max_len;
}

void dumppipe(UCHAR ifnum, DWORD loopcount, int x)
{
	HUSB husb;
	HANDLE h[6];
	unsigned char *buf;
	DWORD size, ret, i, j, maxlen;
	husb = Uusbd_Open();
	if(husb == INVALID_HANDLE_VALUE) {
		printf("Can not find the USB device using Uusbd.sys\n");
		return;
	}
	ret = Uusbd_Check(husb);
	if(ret != UU_CHECK_OK) {
		printf("IOCTL error\n");
		return;
	}
	maxlen = get_max_packet(husb, ifnum, 0);
	if(maxlen == 0) {
		printf("Can't Get max packet length\n");
		return;
	}
	printf("max packet size =%d\n",maxlen);

	buf = (char*)malloc(maxlen);

	for(i = 0; i < 6; i ++)
	{
		h[i] = Uusbd_OpenPipe(husb, ifnum, (UCHAR)i);
	}
	Uusbd_ResetDevice(husb);
	for(i=0;i<6;i+=2){
		memset(buf, 0, maxlen);
		sprintf(buf, "out pipe %d", i+1);
		size = strlen(buf);
		ret = WriteFile(h[i+1], buf, size, &size, NULL);
		ret = ReadFile(h[i], buf, maxlen, &size, NULL);
		if(ret ==0 || size == 0) {
			printf("read error ret=%d size=%d\n",ret,size);
			ret = Uusbd_Check(husb);
			if(ret != UU_CHECK_OK) {
				printf("device is out of system\n");
				break;
			}
			Uusbd_ResetPipe(h);
			Sleep(100);
			continue;
		}
		printf("%05d:",i);
		for(j=0;j<size;j++){
			printf("%02X ", buf[j]);
		}
		printf("\n");
	}

	CloseHandle(h);
	Uusbd_Close(husb);
	free(buf);
}

void main(void)
{
	dumppipe(NUM_INTERFACE, LOOPCOUNT,1);
}